
// routine to load a given mode
int def_uff::LoadMode(int num)
{
 int imode, ipt,nbrmode;
 // Resetting everything
 for (ipt=0; ipt<NbrNodes; ipt++)
     { DepReal[ipt].x=PosRef[ipt].x; DepImag[ipt].x=PosRef[ipt].x; 
       DepReal[ipt].y=PosRef[ipt].y; DepImag[ipt].y=PosRef[ipt].y; 
       DepReal[ipt].z=PosRef[ipt].z; DepImag[ipt].z=PosRef[ipt].z; 
       node[ipt].x=PosRef[ipt].x; node[ipt].y=PosRef[ipt].y;
       node[ipt].z=PosRef[ipt].z; }
 NbrImages=0;

 // Controlling mode number
 if (num<1) return 1;

 ifstream UffFile(FileName);
 if (!UffFile) { return 1; }
 char **Mot;
 Mot=new char*[20];
 int im;
 for (im=0;im<20;im++) Mot[im]=new char[30];

 int ComplexData, WithRot,NbrWords;
 // Skipping the first blocks of type 55
 for (imode=1; imode<num; imode++)
   {
   if (FindNextUff(UffFile,55,Mot)) { NbrImages=0; return 1; }
   if (FindNextMinusOne(UffFile,Mot)) { NbrImages=0; return 1; }
   }
 // up to the right one 
 if (FindNextUff(UffFile,55,Mot)) { NbrImages=0; return 1; }
 // Skipping the 5 comment lines
 for (im=0; im<5; im++)  if (GetWordsInLine(UffFile,NbrWords,Mot))
   { NbrImages=0; return 2; } 
 // Reading data parameters
 if (GetWordsInLine(UffFile,NbrWords,Mot))
   { NbrImages=0; return 2; }  
 if (NbrWords!=6)
   { NbrImages=0; cout << "Record 6: incorrect number of values\n"; return 2; }  
 if (strcmp(Mot[0],"1")!=0)
   { NbrImages=0; cout << "Model not structural\n"; return 2; }  
// if (strcmp(Mot[1],"2")!=0)
//   { NbrImages=0; cout << "Analysis not modal\n"; return 9; }  
 if ((strcmp(Mot[1],"2")!=0) && (strcmp(Mot[1],"3")!=0))
  { NbrImages=0; cout << "Bad data type\n"; return 9; }  
 if (!strcmp(Mot[1],"2")) ComplexData=0;
 if (!strcmp(Mot[1],"3")) ComplexData=1;
 if ((strcmp(Mot[2],"2")!=0) && (strcmp(Mot[2],"3")!=0))
   { NbrImages=0; cout << "Bad data type\n"; return 2; }  
 if (!strcmp(Mot[2],"2")) WithRot=0;
 if (!strcmp(Mot[2],"3")) WithRot=1;
 if ((strcmp(Mot[4],"2")!=0) && (strcmp(Mot[4],"5")!=0))
   { NbrImages=0; cout << "Bad data type\n"; return 2; }  
 if (!strcmp(Mot[4],"2") && (ComplexData==1))
   { NbrImages=0; cout << "Incoherence between real and complex mode\n"; return 9; }  
 if (!strcmp(Mot[4],"5") && (ComplexData==0))
   { NbrImages=0; cout << "Incoherence between real and complex mode\n"; return 9; }  
 if (WithRot &&  (strcmp(Mot[5],"6")!=0))
   { NbrImages=0; cout << "NDV incorrect\n"; return 9; }  
 if ((WithRot==0) &&  (strcmp(Mot[5],"3")!=0))
   { NbrImages=0; cout << "NDV incorrect\n"; return 9; }  
 // Skipping record 7
 if (GetWordsInLine(UffFile,NbrWords,Mot))
   { NbrImages=0; return 2; }  
 // Reading record 8
 if (GetWordsInLine(UffFile,NbrWords,Mot))
   { NbrImages=0; return 2; }  
 if (ComplexData==0) 
    {
    if (NbrWords!=4)
    { NbrImages=0; cout << "Record 8: incorrect number of values\n"; return 9; }
    freq=atof(Mot[0]);
    amor=atof(Mot[2]);
    }
 if (ComplexData==1) 
    {
    if (NbrWords!=6)
    { NbrImages=0; cout << "Record 8: incorrect number of values\n"; return 9; }
    double sigma, omega;
    sigma=atof(Mot[0]);
    omega=atof(Mot[1]);
    freq=sqrt(sigma*sigma+omega*omega)/(2*3.14159265);
    amor=-sigma/(2*3.14159265*freq);
    }
 cout << "freq=" << freq << " amor=" << amor << endl;
 // Initialisation of DepMax to avoid divisions by zero
 DepMax=1E-9;
 do
  {
  if (GetWordsInLine(UffFile,NbrWords,Mot)) { NbrImages=-1; }
  if (strcmp(Mot[0],"-1")!=0)
   {
   ipt=GetNumNodeOfName(Mot[0]);
   cout << "Node " << Mot[0] << endl;
   if (ipt<0) { NbrImages=-1; }
   if(ipt!=-1)
     {
     if (GetWordsInLine(UffFile,NbrWords,Mot)) { NbrImages=-1; }
     cout << "NbrWords=" << NbrWords << " WithRot=" << WithRot 
          << " Cplx=" << ComplexData << endl;
     if (NbrWords!=(3*(1+ComplexData)*(1+WithRot)))
      { NbrImages=-1; cout<<"Record 10: incorrect number of data\n"; }
     if (ComplexData)
       {
       DepReal[ipt].x=PosRef[ipt].x+atof(Mot[0]);
       DepImag[ipt].x=PosRef[ipt].x+atof(Mot[1]);
       DepReal[ipt].y=PosRef[ipt].y+atof(Mot[2]); 
       DepImag[ipt].y=PosRef[ipt].y+atof(Mot[3]);
       DepReal[ipt].z=PosRef[ipt].z+atof(Mot[4]); 
       DepImag[ipt].z=PosRef[ipt].z+atof(Mot[6]);
       }
     else
       {
       DepReal[ipt].x=PosRef[ipt].x+atof(Mot[0]);
       DepReal[ipt].y=PosRef[ipt].y+atof(Mot[1]);
       DepReal[ipt].z=PosRef[ipt].z+atof(Mot[2]);
       }
     if (fabs(DepReal[ipt].x-PosRef[ipt].x)>DepMax) 
       DepMax=fabs(DepReal[ipt].x-PosRef[ipt].x);
     if (fabs(DepReal[ipt].y-PosRef[ipt].y)>DepMax) 
       DepMax=fabs(DepReal[ipt].y-PosRef[ipt].y);
     if (fabs(DepReal[ipt].z-PosRef[ipt].z)>DepMax) 
       DepMax=fabs(DepReal[ipt].z-PosRef[ipt].z);
     if (fabs(DepImag[ipt].x-PosRef[ipt].x)>DepMax) 
       DepMax=fabs(DepImag[ipt].x-PosRef[ipt].x);
     if (fabs(DepImag[ipt].y-PosRef[ipt].y)>DepMax) 
       DepMax=fabs(DepImag[ipt].y-PosRef[ipt].y);
     if (fabs(DepImag[ipt].z-PosRef[ipt].z)>DepMax) 
       DepMax=fabs(DepImag[ipt].z-PosRef[ipt].z);
     }
   }
  }
 while ((NbrWords!=1) || (strcmp(Mot[0],"-1")!=0));

 UffFile.close();
 if (NbrImages==-1) 
   {
   // Puisque ca n'a pas marche, on remet tout a zero
     alpha=0.0; beta=0.0; freq=0.0; amor=0.0;
   for (ipt=0; ipt<NbrNodes; ipt++)
     { DepReal[ipt].x=PosRef[ipt].x; DepImag[ipt].x=PosRef[ipt].x; 
       DepReal[ipt].y=PosRef[ipt].y; DepImag[ipt].y=PosRef[ipt].y; 
       DepReal[ipt].z=PosRef[ipt].z; DepImag[ipt].z=PosRef[ipt].z; 
       node[ipt].x=PosRef[ipt].x; node[ipt].y=PosRef[ipt].y;
       node[ipt].z=PosRef[ipt].z; }
   NbrImages=0;
   return 2;
   }

 float lcaract;
 lcaract=sqrt((xmax-xmin)*(xmax-xmin)+(ymax-ymin)*(ymax-ymin)
               +(zmax-zmin)*(zmax-zmin));
 for (ipt=0;ipt<NbrNodes;ipt++)
      {
      node[ipt].x=PosRef[ipt].x
                +(DepReal[ipt].x-PosRef[ipt].x)*0.05*lcaract/DepMax;
      node[ipt].y=PosRef[ipt].y
                +(DepReal[ipt].y-PosRef[ipt].y)*0.05*lcaract/DepMax;
      node[ipt].z=PosRef[ipt].z
                +(DepReal[ipt].z-PosRef[ipt].z)*0.05*lcaract/DepMax;
      }
 CurImage=0;
 NbrImages=50;
 return 0;
}	

/*---------------------------------------------------------------------*/

